/* A C version of reading the first word */
// $> gcc ReadFirstWord.c #compile
// $> ./a.out             #run
#include <stdio.h>
#include <string.h>
#include <errno.h>
extern int errno ;
int main (){
  FILE *f;
  f = fopen("names-ages.txt","r");
  if (f == NULL) {
    // Control jumps here if there was a problem
    printf( "Error %d: %s\n", errno, strerror(errno));
    return -1;			/* An error happened */
  }
  // Control gets here if the file opened successfully
  char word[128];
  printf("Reading first word\n");
  fscanf(f,"%s",word);
  printf("First word: %s\n",word);
  fclose (f);
}
