// Demonstration of most to least specific processing of exceptions
class SpecialException extends Exception {
  public SpecialException(String s){
    super(s);
  }
}
class DeluxeException extends SpecialException {
  public DeluxeException(String s){
    super(s);
  }
}

public class TieredExceptions{

  public static void throwMeSomethinSpecial() throws Exception{
    throw new Exception("BAM!");
    //    throw new DeluxeException("BAM!");
    //throw new SpecialException("BAM!");
  }

  public static void main(String args[]) throws Exception{
    try{
      System.out.println("About to try something dangerous");
      throwMeSomethinSpecial();
    }
    catch(DeluxeException e){	
      System.out.println("Deluxe: "+e.getMessage());
    }
    catch(SpecialException e){
      System.out.println("Special: "+e.getMessage());
    }
    catch(Exception e){
      System.out.println("Regular: "+e.getMessage());
    }
  }
}
