// usage: java HandleErrors names-ages.txt
// 
// Read records of the format
//   firstname   lastname   age
//   firstname   lastname   age
//   firstname   lastname   age
// and print the results.
// 
// While reading records, any errors that arise will cause the program
// to crash
import java.io.*;
import java.util.*;
public class CrashOnErrors{
  public static void main(String args[])
    throws FileNotFoundException
  {
    if(args.length < 1){
      System.out.println("usage: java CrashOnErrors file");
      return;
    }

    String filename = args[0];
    String first, last;
    int age;
    int lineNum=0, errorCount=0;
    Scanner f = new Scanner(new File(filename));
    for(lineNum=1, errorCount=0; f.hasNext(); lineNum++){
      String line = f.nextLine();
      Scanner oneLine = new Scanner(line);
      first = oneLine.next();
      last = oneLine.next();
      age = oneLine.nextInt();
      System.out.printf("Successfully read %s %s %d\n",
                        first, last, age);
    }
    f.close();
  }
}
