// A java version of reading the first word in a file
// $> javac ReadFirstWord.java #compile
// $> java ReadFile            #run
import java.io.*;
import java.util.*;
public class ReadFirstWord{
  public static void main(String args[]){
    Scanner f;
    try {
      f = new Scanner(new File("names-ages.txt"));
      // Control gets here if the file opened successfully
      System.out.println("Reading first word");
      String word = f.next();
      System.out.printf("First word: %s\n",word);
      f.close();
    }
    catch(FileNotFoundException e){
      // Control jumps here if there was a problem
      System.out.println("Error: "+e.getMessage());
    }
  }
}
