// Simplest demonstration of how exceptions are thrown and caught
public class SimpleExceptions{
  public static void main(String args[]) throws Exception //Not needed
  { successMethod();            // Should make it through
    try{
      failMethod();
      failMethod();
    }
    catch(Exception e){
      System.out.println("Don't do that again");
    }
  }
  // Throws exceptions but catches/handles them
  public static void successMethod(){
    System.out.println("About to try something dangerous");
    try{
      failMethod();
      System.out.println("Glad that's over.");
    }
    catch(Exception e){
      System.out.printf("Handling error %s\n", e.toString());
    }
    finally{
      System.out.println("Nothing else to do");
    }
    System.out.println("Another success");
  }

  // Always throws an exception
  public static void failMethod() throws Exception
  {
    Exception e = new Exception("FAIL!!");
    System.out.println("Oh crap");
    throw e;
    //    System.out.println("Failed."); // Unreachable
  }
}
